
%global release_version 2
%global _ovirt_version 1.0.13

Name: ovirt-guest-agent
Version: 1.0.13
Release: %{release_version}%{?candidate_rel}%{?dist}
Summary: The oVirt Guest Agent
Group: Applications/System
License: ASL 2.0
URL: http://wiki.ovirt.org/wiki/Category:Ovirt_guest_agent
Source0: http://evilissimo.fedorapeople.org/releases/ovirt-guest-agent/%{version}/%{name}-%{_ovirt_version}.tar.bz2

BuildArch: noarch
BuildRoot: %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
BuildRequires: python2-devel
BuildRequires: python-pep8
Requires: python-simplejson
Requires: dbus-python
Requires: python-ctypes
Requires: rpm-python
Requires: python-ethtool >= 0.4-1
Requires: udev >= 095-14.23
Requires: usermode
Requires(post): chkconfig
Requires(preun): chkconfig
Requires(preun): initscripts

Conflicts: rhev-agent
Conflicts: rhevm-guest-agent
Conflicts: rhevm-guest-agent-common

%description
This is the oVirt management agent running inside the guest. The agent
interfaces with the oVirt manager, supplying heart-beat info as well as
run-time data from within the guest itself. The agent also accepts
control commands to be run executed within the OS (like: shutdown and
restart).

%prep
%setup -q -n ovirt-guest-agent-%{_ovirt_version}

%configure --without-sso

sed -i 's/except hooks.UnknownHookError as e/except hooks.UnknownHookError, e/' ovirt-guest-agent/OVirtAgentLogic.py

make %{?_smp_mflags}

%install
rm -rf %{buildroot}
pushd .
make -C ovirt-guest-agent -f Makefile.el5 install DESTDIR=%{buildroot}
popd
mkdir -p %{buildroot}%{_localstatedir}/log/ovirt-guest-agent
mkdir -p %{buildroot}%{_localstatedir}/lock/subsys/ovirt-guest-agent

mkdir -p %{buildroot}%{_datadir}/ovirt-guest-agent
mkdir -p %{buildroot}%{_datadir}/ovirt-guest-agent/scripts
mkdir -p %{buildroot}%{_datadir}/ovirt-guest-agent/scripts/hooks
mkdir -p %{buildroot}%{_datadir}/ovirt-guest-agent/scripts/hooks/defaults
mkdir -p %{buildroot}%{_datadir}/ovirt-guest-agent/scripts/hooks/before_migration
mkdir -p %{buildroot}%{_datadir}/ovirt-guest-agent/scripts/hooks/before_hibernation
mkdir -p %{buildroot}%{_datadir}/ovirt-guest-agent/scripts/hooks/after_migration
mkdir -p %{buildroot}%{_datadir}/ovirt-guest-agent/scripts/hooks/after_hibernation

mkdir -p %{buildroot}%{_sysconfdir}/ovirt-guest-agent
mkdir -p %{buildroot}%{_sysconfdir}/ovirt-guest-agent/hooks.d
mkdir -p %{buildroot}%{_sysconfdir}/ovirt-guest-agent/hooks.d/before_migration
mkdir -p %{buildroot}%{_sysconfdir}/ovirt-guest-agent/hooks.d/after_migration
mkdir -p %{buildroot}%{_sysconfdir}/ovirt-guest-agent/hooks.d/before_hibernation
mkdir -p %{buildroot}%{_sysconfdir}/ovirt-guest-agent/hooks.d/after_hibernation

install -m 755 hooks/55-flush-caches.consolehelper %{buildroot}%{_datadir}/ovirt-guest-agent/scripts/hooks/defaults/55-flush-caches
install -m 755 hooks/flush-caches %{buildroot}%{_datadir}/ovirt-guest-agent/scripts/hooks/defaults/flush-caches

ln -sf /usr/share/ovirt-guest-agent/hooks/defaults/55-flush-caches %{buildroot}%{_datadir}/ovirt-guest-agent/scripts/hooks/before_hibernation/55-flush-caches
ln -sf /usr/share/ovirt-guest-agent/hooks/defaults/55-flush-caches %{buildroot}%{_datadir}/ovirt-guest-agent/scripts/hooks/before_migration/55-flush-caches
ln -sf /usr/share/ovirt-guest-agent/hooks.d/before_migration/55-flush-caches %{buildroot}%{_sysconfdir}/ovirt-guest-agent/hooks.d/before_migration/55-flush-caches
ln -sf /usr/share/ovirt-guest-agent/hooks.d/before_hibernation/55-flush-caches %{buildroot}%{_sysconfdir}/ovirt-guest-agent/hooks.d/before_hibernation/55-flush-caches

install -m 644 ovirt-guest-agent/pam/ovirt-flush-caches %{buildroot}%{_sysconfdir}/pam.d/ovirt-flush-caches
install -m 644 ovirt-guest-agent/pam/ovirt-logout %{buildroot}%{_sysconfdir}/pam.d/ovirt-logout
install -m 644 ovirt-guest-agent/pam/ovirt-logout %{buildroot}%{_sysconfdir}/pam.d/ovirt-locksession

install -m 644 ovirt-guest-agent/consoleapps/ovirt-flush-caches %{buildroot}%{_sysconfdir}/security/console.apps/ovirt-flush-caches
install -m 644 ovirt-guest-agent/consoleapps/ovirt-locksession %{buildroot}%{_sysconfdir}/security/console.apps/ovirt-locksession
install -m 644 ovirt-guest-agent/consoleapps/ovirt-logout %{buildroot}%{_sysconfdir}/security/console.apps/ovirt-logout

install -m 755 ovirt-guest-agent/LockActiveSession.py %{buildroot}%{_datadir}/ovirt-guest-agent/LockActiveSession.py
install -m 755 ovirt-guest-agent/LogoutActiveUser.py %{buildroot}%{_datadir}/ovirt-guest-agent/LogoutActiveUser.py
install -m 644 ovirt-guest-agent/timezone.py %{buildroot}%{_datadir}/ovirt-guest-agent/timezone.py
install -m 644 ovirt-guest-agent/hooks.py %{buildroot}%{_datadir}/ovirt-guest-agent/hooks.py

install -m 755 scripts/ovirt-osinfo %{buildroot}%{_datadir}/ovirt-guest-agent/ovirt-osinfo

ln -sf /usr/bin/consolehelper %{buildroot}%{_datadir}/ovirt-guest-agent/ovirt-shutdown
ln -sf /usr/bin/consolehelper %{buildroot}%{_datadir}/ovirt-guest-agent/ovirt-hibernate
ln -sf /usr/bin/consolehelper %{buildroot}%{_datadir}/ovirt-guest-agent/ovirt-locksession
ln -sf /usr/bin/consolehelper %{buildroot}%{_datadir}/ovirt-guest-agent/ovirt-logout
ln -sf /usr/bin/consolehelper %{buildroot}%{_datadir}/ovirt-guest-agent/ovirt-flush-caches

mv %{buildroot}%{_datadir}/ovirt-guest-agent/diskmapper{.el5,}

%clean
rm -rf %{buildroot}

%pre
getent group ovirtagent >/dev/null || groupadd -r -g 175 -o ovirtagent
getent passwd ovirtagent > /dev/null || \
    /usr/sbin/useradd -u 175 -g 175 -o -r ovirtagent \
    -c "oVirt Guest Agent" -d / -s /sbin/nologin
exit 0

%post
/sbin/chkconfig --add ovirt-guest-agent


%preun
if [ "$1" -eq 0 ]; then
    /sbin/service ovirt-guest-agent stop > /dev/null 2>&1
    /sbin/chkconfig --del ovirt-guest-agent

    # non blocking uninstalled notification
    echo -e '{"__name__": "uninstalled"}\n' | dd \
        of=/dev/virtio-ports/com.redhat.rhevm.vdsm \
        oflag=nonblock status=noxfer conv=nocreat 1>& /dev/null || :

    echo -e '{"__name__": "uninstalled"}\n' | dd \
        of=/dev/virtio-ports/ovirt-guest-agent.0 \
        oflag=nonblock status=noxfer conv=nocreat 1>& /dev/null || :
fi

%postun

if [ "$1" -ge 1 ]; then
    /sbin/service ovirt-guest-agent condrestart > /dev/null 2>&1
fi

%files
%dir %attr (755,ovirtagent,ovirtagent) %{_localstatedir}/log/ovirt-guest-agent
%dir %attr (755,root,root) %{_datadir}/ovirt-guest-agent

# Hook configuration directories
%dir %attr (755,root,root) %{_sysconfdir}/ovirt-guest-agent
%dir %attr (755,root,root) %{_sysconfdir}/ovirt-guest-agent/hooks.d
%dir %attr (755,root,root) %{_sysconfdir}/ovirt-guest-agent/hooks.d/before_migration
%dir %attr (755,root,root) %{_sysconfdir}/ovirt-guest-agent/hooks.d/after_migration
%dir %attr (755,root,root) %{_sysconfdir}/ovirt-guest-agent/hooks.d/before_hibernation
%dir %attr (755,root,root) %{_sysconfdir}/ovirt-guest-agent/hooks.d/after_hibernation

# Hook installation directories
%dir %attr (755,root,root) %{_datadir}/ovirt-guest-agent/scripts
%dir %attr (755,root,root) %{_datadir}/ovirt-guest-agent/scripts/hooks/
%dir %attr (755,root,root) %{_datadir}/ovirt-guest-agent/scripts/hooks/defaults
%dir %attr (755,root,root) %{_datadir}/ovirt-guest-agent/scripts/hooks/before_migration
%dir %attr (755,root,root) %{_datadir}/ovirt-guest-agent/scripts/hooks/after_migration
%dir %attr (755,root,root) %{_datadir}/ovirt-guest-agent/scripts/hooks/before_hibernation
%dir %attr (755,root,root) %{_datadir}/ovirt-guest-agent/scripts/hooks/after_hibernation

%config(noreplace) %{_sysconfdir}/ovirt-guest-agent.conf

%doc AUTHORS COPYING NEWS README

# These are intentionally NOT 'noreplace' If this is modified by an user,
# this actually might break it.
%config(noreplace) %{_sysconfdir}/pam.d/ovirt-logout
%config(noreplace) %{_sysconfdir}/pam.d/ovirt-locksession
%config(noreplace) %{_sysconfdir}/pam.d/ovirt-shutdown
%config(noreplace) %{_sysconfdir}/pam.d/ovirt-hibernate
%config(noreplace) %{_sysconfdir}/pam.d/ovirt-logout
%config(noreplace) %{_sysconfdir}/pam.d/ovirt-flush-caches
%config %attr (644,root,root) %{_sysconfdir}/udev/rules.d/55-ovirt-guest-agent.rules
%config %{_sysconfdir}/security/console.apps/ovirt-shutdown
%config %{_sysconfdir}/security/console.apps/ovirt-hibernate
%config %{_sysconfdir}/security/console.apps/ovirt-locksession
%config %{_sysconfdir}/security/console.apps/ovirt-logout
%config(noreplace) %{_sysconfdir}/security/console.apps/ovirt-flush-caches

%attr (755,root,root) %{_datadir}/ovirt-guest-agent/ovirt-guest-agent.py*

%attr (755,root,root) %{_datadir}/ovirt-guest-agent/scripts/hooks/defaults/55-flush-caches
%attr (755,root,root) %{_datadir}/ovirt-guest-agent/scripts/hooks/defaults/flush-caches

%{_datadir}/ovirt-guest-agent/default.conf
%{_datadir}/ovirt-guest-agent/default-logger.conf
%{_datadir}/ovirt-guest-agent/bytesio.py*
%attr (755,root,root) %{_datadir}/ovirt-guest-agent/diskmapper


%attr (644,root,root) %{_datadir}/ovirt-guest-agent/default.conf
%attr (644,root,root) %{_datadir}/ovirt-guest-agent/default-logger.conf

%{_datadir}/ovirt-guest-agent/timezone.py*
%{_datadir}/ovirt-guest-agent/hooks.py*
%{_datadir}/ovirt-guest-agent/GuestAgentLinux2.py*
%{_datadir}/ovirt-guest-agent/OVirtAgentLogic.py*
%{_datadir}/ovirt-guest-agent/VirtIoChannel.py*

# consolehelper symlinks
%attr (755,root,root) %{_datadir}/ovirt-guest-agent/ovirt-osinfo
%{_datadir}/ovirt-guest-agent/ovirt-logout
%{_datadir}/ovirt-guest-agent/ovirt-flush-caches
%{_datadir}/ovirt-guest-agent/ovirt-locksession
%{_datadir}/ovirt-guest-agent/ovirt-shutdown
%{_datadir}/ovirt-guest-agent/ovirt-hibernate

%attr (755,root,root) %{_datadir}/ovirt-guest-agent/LockActiveSession.py*
%attr (755,root,root) %{_datadir}/ovirt-guest-agent/LogoutActiveUser.py*
%attr (755,root,root) %{_datadir}/ovirt-guest-agent/hibernate

# Symlinks for the default hooks
%config(noreplace) %{_datadir}/ovirt-guest-agent/scripts/hooks/before_hibernation/55-flush-caches
%config(noreplace) %{_datadir}/ovirt-guest-agent/scripts/hooks/before_migration/55-flush-caches
%config(noreplace) %{_sysconfdir}/ovirt-guest-agent/hooks.d/before_hibernation/55-flush-caches
%config(noreplace) %{_sysconfdir}/ovirt-guest-agent/hooks.d/before_migration/55-flush-caches

%attr (755,root,root) %{_sysconfdir}/init.d/ovirt-guest-agent


%changelog
* Tue Feb 14 2017 Vinzenz Feenstra <evilissimo@redhat.com> - 1.0.13-2
- Add support for future channel name

* Tue Feb 07 2017 Vinzenz Feenstra <evilissimo@redhat.com> - 1.0.13-1
- Bump to upstream version 1.0.13

* Tue Jul 26 2016 Vinzenz Feenstra <evilissimo@redhat.com> - 1.0.12-4
- Bump to upstream version 1.0.12.2

* Tue Jun 21 2016 Vinzenz Feenstra <evilissimo@redhat.com> - 1.0.12-3
- Fixing python syntax error on EL5

* Tue Jun 21 2016 Vinzenz Feenstra <evilissimo@redhat.com> - 1.0.12-2
- Bump to upstream version 1.0.12.1

* Thu May 19 2016 Vinzenz Feenstra <evilissimo@redhat.com> - 1.0.12-1
- Bump to upstream version 1.0.12

* Tue Apr 05 2016 Vinzenz Feenstra <evilissimo@redhat.com> - 1.0.11-3
- Bump to upstream version 1.0.11.3

* Tue Aug 18 2015 Vinzenz Feenstra <evilissimo@redhat.com> - 1.0.11-2
  - Adding missing dependency python-ctypes (RHBZ#1254358)

* Mon Jul 20 2015 Vinzenz Feenstra <evilissimo@redhat.com> - 1.0.11-1
  - Update to upstream version ovirt-guest-agent 1.0.11

* Wed Oct 01 2014 Vinzenz Feenstra <evilissimo@redhat.com> - 1.0.10.2-1
- Update to latest upstream release

* Tue Jul 01 2014 Vinzenz Feenstra <evilissimo@redhat.com> - 1.0.10-1
  - Update to version ovirt-guest-agent 1.0.10

* Thu Jan 30 2014 Vinzenz Feenstra <evilissimo@redhat.com> - 1.0.9-1
  - Update to version ovirt-guest-agent 1.0.9

* Wed Nov 27 2013 Vinzenz Feenstra <evilissimo@redhat.com> - 1.0.8-7
  - Adding python-simplejson as dependency

* Tue Nov 26 2013 Vinzenz Feenstra <evilissimo@redhat.com> - 1.0.8-6
  - Use the override flag for groupadd

* Mon Nov 25 2013 Vinzenz Feenstra <evilissimo@redhat.com> - 1.0.8-5
  - Added python2.4 syntax fix

* Mon Nov 25 2013 Vinzenz Feenstra <evilissimo@redhat.com> - 1.0.8-4
  - Removed selinux policy conflicts

* Mon Nov 25 2013 Vinzenz Feenstra <evilissimo@redhat.com> - 1.0.8-3
  - EL5 adjustments and update to upstream 1.0.8.1 sources

* Thu Jul 11 2013 Vinzenz Feenstra <evilissimo@redhat.com> - 1.0.8-1
  - Update to version ovirt-guest-agent 1.0.8

* Wed Jul 10 2013 Vinzenz Feenstra <evilissimo@redhat.com> - 1.0.7-1
  - Initial ovirt-guest-agent RHEL6 package
